from typing import Any
from typing import List
from typing import Set
from typing import Tuple

from . import *


class ParticleSystem(bpy_struct):
    
    active_particle_target: ParticleTarget
    
    active_particle_target_index: int
    
    # Child particles generated by the particle system
    child_particles: List[ChildParticle]
    
    # Offset in the random number table for child particles, to get a different randomized result
    child_seed: int
    
    # Cloth dynamics for hair
    cloth: ClothModifier
    
    # The current simulation time step size, as a fraction of a frame
    dt_frac: float
    
    # Particle system has multiple point caches
    has_multiple_caches: bool
    
    # Negate the effect of the clump vertex group
    invert_vertex_group_clump: bool
    
    # Negate the effect of the density vertex group
    invert_vertex_group_density: bool
    
    # Negate the effect of the field vertex group
    invert_vertex_group_field: bool
    
    # Negate the effect of the kink vertex group
    invert_vertex_group_kink: bool
    
    # Negate the effect of the length vertex group
    invert_vertex_group_length: bool
    
    # Negate the effect of the rotation vertex group
    invert_vertex_group_rotation: bool
    
    # Negate the effect of the roughness 1 vertex group
    invert_vertex_group_roughness_1: bool
    
    # Negate the effect of the roughness 2 vertex group
    invert_vertex_group_roughness_2: bool
    
    # Negate the effect of the roughness end vertex group
    invert_vertex_group_roughness_end: bool
    
    # Negate the effect of the size vertex group
    invert_vertex_group_size: bool
    
    # Negate the effect of the tangent vertex group
    invert_vertex_group_tangent: bool
    
    # Negate the effect of the twist vertex group
    invert_vertex_group_twist: bool
    
    # Negate the effect of the velocity vertex group
    invert_vertex_group_velocity: bool
    
    # Particle system can be edited in particle mode
    is_editable: bool
    
    # Particle system has been edited in particle mode
    is_edited: bool
    
    # Hair keys are in global coordinate space
    is_global_hair: bool
    
    # Particle system name
    name: str
    
    # Use this object’s coordinate system instead of global coordinate system
    parent: Object
    
    # Particles generated by the particle system
    particles: List[Particle]
    
    point_cache: PointCache
    
    # For reactor systems, the object that has the target particle system (empty if same object)
    reactor_target_object: Object
    
    # For reactor systems, index of particle system on the target object
    reactor_target_particle_system: int
    
    # Offset in the random number table, to get a different randomized result
    seed: int
    
    # Particle system settings
    settings: ParticleSettings
    
    # Target particle systems
    targets: List[ParticleTarget]
    
    # Enable hair dynamics using cloth simulation
    use_hair_dynamics: bool
    
    # Use key times
    use_keyed_timing: bool
    
    # Vertex group to control clump
    vertex_group_clump: str
    
    # Vertex group to control density
    vertex_group_density: str
    
    # Vertex group to control field
    vertex_group_field: str
    
    # Vertex group to control kink
    vertex_group_kink: str
    
    # Vertex group to control length
    vertex_group_length: str
    
    # Vertex group to control rotation
    vertex_group_rotation: str
    
    # Vertex group to control roughness 1
    vertex_group_roughness_1: str
    
    # Vertex group to control roughness 2
    vertex_group_roughness_2: str
    
    # Vertex group to control roughness end
    vertex_group_roughness_end: str
    
    # Vertex group to control size
    vertex_group_size: str
    
    # Vertex group to control tangent
    vertex_group_tangent: str
    
    # Vertex group to control twist
    vertex_group_twist: str
    
    # Vertex group to control velocity
    vertex_group_velocity: str

    def co_hair(self, *args, **kwargs) -> Tuple[float, float, float]:
        ...

    def uv_on_emitter(self, *args, **kwargs) -> Tuple[float, float]:
        ...

    def mcol_on_emitter(self, *args, **kwargs) -> Tuple[float, float, float]:
        ...

    @classmethod
    def bl_rna_get_subclass(cls, *args, **kwargs) -> Struct:
        ...

    @classmethod
    def bl_rna_get_subclass_py(cls, *args, **kwargs) -> Any:
        ...